#!/bin/sh
# /home/abacus/C2/danholav.sh - ABACUS operator interface 
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0
########################################################################
#
# BIP ABACUS 
#
# Initial version 980907
# 
# 
########################################################################

Pic copy Pic_bip-services
catch { source ./bip-shared.tcl }

button $w.p.ti_hem1  -bitmap @./MCH-Konsulting-small-bw-1.xbm \
  -command { change_to bip-menu }
place $w.p.ti_hem1 -x 0 -y 0 

button $w.p.ti_hem2  -bitmap @./MCH-Konsulting-small-bw-2.xbm \
  -command { change_to bip-evaporat }
place $w.p.ti_hem2 -x 48 -y 0 

button $w.p.ti_prev -bitmap @./big_left_button.xbm \
  -command { change_to bip-menu }
place $w.p.ti_prev -x 113 -y 0 

button $w.p.ti_next -bitmap @./big_right_button.xbm\
  -command { change_to bip-feedstor }
place $w.p.ti_next -x 148 -y 0
 
# button $w.p.ti_hem  -bitmap @./Rowan_House.xbm \
#   -command { change_to bip-menu }
# place $w.p.ti_hem -x 0 -y 35 
 
set tags 1

button $w.p.ti_tag -text "No-tags" \
  -command {
      if { $tags } {
	 catch { Pic copy Pic_bip-services-no-tag 
	         $w.p.ti_tag configure -text "tags"
	         set tags 0 }
      } else {
	 catch { Pic copy Pic_bip-services
	         $w.p.ti_tag configure -text "No-tags"
	         set tags 1 }
      }
    }
place $w.p.ti_tag -x 184 -y 0


############## This is the main dynamic data updating proc ##################
#
#
#

set six  15		
set spx 190		
set unx 260		
set rax 325		
set s1x 420		
set s2x 520		

proc update0 {} {
  global w lfont fg bg NODE
  global six spx unx rax s1x s2x

  global fulltime halftime time_taken

  if { [winfo viewable .] } {

  set time_taken [ time	{
	get_values

## Bar graphs
	catch { bar_by_value G101 [ra 10107]  530 341 590 82 100 blue }

## Numeric values
##	catch { text_item G101val  535 327 "%6.1f %%" [ra 10107] }
	
	catch { text_item TI29val  401 336 "%7.1f \'C" [ra 10277] }
	catch { text_item TI28val  401 257 "%7.1f \'C" [ra 10271] }
	catch { text_item TI29SPval  518 387 "%7.1f \'C MAX" [ra 10275] }
	catch { text_item PIC40val  147 160  "%3.0f mB" [ra 10220] } ;# (BIP1:PIC40.MV.)
	catch { text_item b10224  147 175 "%7.0f "  [ra 10224] } ;# PIC40.SP
	catch { text_item PIC42val  267 90  "%3.0f mB" [ra 10240] } ;# (BIP1:PIC42.MV.)
	catch { text_item b10244  267 105 "%7.0f "  [ra 10244] } ;# PIC42.SP.

## Level alarms
        catch { state_text_2 V110hi   67 245 [vn 10665] " HIGH " white red "      " yellow gray }
        catch { state_text_2 V110lo   67 285 [vn 10664] " LOW  " white red "      " yellow gray }
        
        catch { state_text_2 V111hi  160 245 [vn 10662] " HIGH " white red "      " yellow gray }
        catch { state_text_2 V111lo  160 285 [vn 10663] " LOW  " white red "      " yellow gray }

## Services Status
	catch { state_text_2 b10258  300 275 [vn 10258] "NOT READY" white red " READY " black green } ;# BIP1:SERVICES.READY.
							
## Valves
#### open/close
	catch { shape_2 V16oc  85 339 [vn 10309] valve_onoff_r_open_red-hollow valve_onoff_r_close_green } ;# BIP1:V16.FB. open/closed
#### alarm
	catch { if { [vn 10311] } { shape_2_flash V16al  85 339 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV16al } }
#### hand/auto
	catch { shape_2 V16ha 116 339 [vn 10310] blank hand } ;#  BIP1:V16.STATE. hand/auto

	catch { shape_2 V30oc 179 339 [vn 10325] valve_onoff_r_open_red-hollow valve_onoff_r_close_green } ;#  BIP1:V30.FB. open/closed
	catch { if { [vn 10327] } { shape_2_flash V30al 179 339 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV30al } }
	catch { shape_2 V30ha 208 339 [vn 10326] blank hand } ;#  BIP1:V30.STATE. hand/auto
	
## Pumps
#### run/stop
	#catch { shape_2 P13  166 139 [vn 10171] pump_r_green pump_r_red} ;# BIP1:P13.FB.
#### alarm
	catch \
	  { 
	    if { [vn 10173] } \
	      {
		shape_2_flash P13al 166 155 1 alarm_blob alarm_blob_gray
		shape_2_flash P13  166 139 [vn 10171] pump_r_green pump_r_red ;# BIP1:P13.FB.
	      } else { 
		destroy $w.p.tiP13al
		shape_2       P13  166 139 [vn 10171] pump_r_green pump_r_red ;# BIP1:P13.FB.
	      }
	  }
#### hand/auto
	catch { shape_2 P13ha  185 150 [vn 10172] blank hand } ;#  BIP1:P13.STATE. hand/auto

	catch { shape_2 P14  287 139 [vn 10174] pump_r_green pump_r_red} ;# BIP1:P14.FB. 10174
	catch { if { [vn 10176] } { shape_2_flash P14al 287 139 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP14al } }
	catch { shape_2 P14ha  304 150 [vn 10175] blank hand } ;#  BIP1:P14.STATE. hand/auto

	catch { shape_2 P10  494 176 [vn 10162] pump_r_green pump_r_red} ;# BIP1:P10.FB.
	catch { if { [vn 10164] } { shape_2_flash P10al 494 176 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP10al } }
	catch { shape_2 P10ha   515 188 [vn 10163] blank hand } ;#  BIP1:P10.STATE. hand/auto
	

	catch { shape_2 P6  116 400 [vn 10194] pump_r_green pump_r_red} ;# BIP1:P6.FB.
	catch { if { [vn 10196] } { shape_2_flash P6al 116 400 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP6al } }
	catch { shape_2 P6ha   135 388 [vn 10195] blank hand } ;#  BIP1:P6.STATE. hand/auto

	catch { shape_2 P7  210 368 [vn 10197] pump_r_green pump_r_red} ;# BIP1:P7.FB. 10174
	catch { if { [vn 10199] } { shape_2_flash P7al 210 368 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP7al } }
	catch { shape_2 P7ha 228 359 [vn 10198] blank hand } ;#  BIP1:P7.STATE. hand/auto

	catch { shape_2 P11  468 338 [vn 10165] pump_r_green pump_r_red} ;# BIP1:P11.FB.
	catch { if { [vn 10167] } { shape_2_flash P11al 468 338 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP11al } }
	catch { shape_2 P11ha  485 349 [vn 10166] blank hand } ;#  BIP1:P11.STATE. hand/auto
	
	blink_change
     }]
  }

################# Here we queue up this proc again ##########################

##
	show_time $time_taken
	catch { after cancel update0 }
	after $fulltime update0
	}


set bg	#D0D0D0
set bg	grey70
set fg  MidnightBlue
set fg	yellow
set fg	darkgreen
set fg	black
set fg	darkblue
 	
set lfont {courier 10 bold}

update0
update idletasks

## Valves
 catch { $w.p.tiV16oc  configure -command { entry_valve_hand_auto_bip_3  10309 10633 10310 "V16" "VALVE: V16"   } }
 catch { $w.p.tiV30oc  configure -command { entry_valve_hand_auto_bip_3  10325 10637 10326 "V30" "VALVE: V30"   } }

## Pumps
 catch { $w.p.tiP13    configure -command { entry_pump_hand_auto_bip  10171 10617 10172 "P13" "PUMP: P13"   } }
 catch { $w.p.tiP13al  configure -command { entry_pump_hand_auto_bip  10171 10617 10172 "P13" "PUMP: P13"   } }


 catch { $w.p.tiP14    configure -command { entry_pump_hand_auto_bip  10174 10618 10175 "P14" "PUMP: P14"   } }
 catch { $w.p.tiP14al  configure -command { entry_pump_hand_auto_bip  10174 10618 10175 "P14" "PUMP: P14"   } }

 catch { $w.p.tiP10    configure -command { entry_pump_hand_auto_bip  10162 10619 10163 "P10" "PUMP: P10"   } }
 catch { $w.p.tiP10al  configure -command { entry_pump_hand_auto_bip  10162 10619 10163 "P10" "PUMP: P10"   } }

 catch { $w.p.tiP6    configure -command { entry_pump_hand_auto_bip  10194 10620 10195 "P6" "PUMP: P6"   } }
 catch { $w.p.tiP6al  configure -command { entry_pump_hand_auto_bip  10194 10620 10195 "P6" "PUMP: P6"   } }

 catch { $w.p.tiP7    configure -command { entry_pump_hand_auto_bip  10197 10621 10198 "P7" "PUMP: P7"   } }
 catch { $w.p.tiP7al  configure -command { entry_pump_hand_auto_bip  10197 10621 10198 "P7" "PUMP: P7"   } }

 catch { $w.p.tiP11    configure -command { entry_pump_hand_auto_bip  10165 10622 10166 "P11" "PUMP: P11"   } }
 catch { $w.p.tiP11al  configure -command { entry_pump_hand_auto_bip  10165 10622 10166 "P11" "PUMP: P11"   } }

